Add keystone charm and interface
[osm/devops.git] / installers / charmed_install.sh
1 #! /bin/bash
2 #
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6 #
7 # http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14 #
15
16 # set -eux
17
18 K8S_CLOUD_NAME="k8s-cloud"
19 KUBECTL="microk8s.kubectl"
20 IMAGES_OVERLAY_FILE=~/.osm/images-overlay.yaml
21 function check_arguments(){
22 while [ $# -gt 0 ] ; do
23 case $1 in
24 --bundle) BUNDLE="$2" ;;
25 --k8s) KUBECFG="$2" ;;
26 --vca) CONTROLLER="$2" ;;
27 --lxd) LXD_CLOUD="$2" ;;
28 --lxd-cred) LXD_CREDENTIALS="$2" ;;
29 --microstack) MICROSTACK=y ;;
30 --ha) BUNDLE="cs:osm-ha" ;;
31 --tag) TAG="$2" ;;
32 esac
33 shift
34 done
35
36 # echo $BUNDLE $KUBECONFIG $LXDENDPOINT
37 }
38
39 function install_snaps(){
40 if [ ! -v KUBECFG ]; then
41 sudo snap install microk8s --classic
42 sudo usermod -a -G microk8s `whoami`
43 mkdir -p ~/.kube
44 sudo chown -f -R `whoami` ~/.kube
45 KUBEGRP="microk8s"
46 else
47 KUBECTL="kubectl"
48 sudo snap install kubectl --classic
49 export KUBECONFIG=${KUBECFG}
50 KUBEGRP=$(id -g -n)
51 fi
52 sudo snap install juju --classic --channel=2.8/stable
53 }
54
55 function bootstrap_k8s_lxd(){
56 [ -v CONTROLLER ] && ADD_K8S_OPTS="--controller ${CONTROLLER}" && CONTROLLER_NAME=$CONTROLLER
57 [ ! -v CONTROLLER ] && ADD_K8S_OPTS="--client" && BOOTSTRAP_NEEDED="yes" && CONTROLLER_NAME="osm-vca"
58
59 if [ -v BOOTSTRAP_NEEDED ]; then
60 CONTROLLER_PRESENT=$(juju controllers 2>/dev/null| grep ${CONTROLLER_NAME} | wc -l)
61 if [ $CONTROLLER_PRESENT -ge 1 ]; then
62 cat << EOF
63 Threre is already a VCA present with the installer reserved name of "${CONTROLLER_NAME}".
64 You may either explicitly use this VCA with the "--vca ${CONTROLLER_NAME}" option, or remove it
65 using this command:
66
67 juju destroy-controller --release-storage --destroy-all-models -y ${CONTROLLER_NAME}
68
69 Please retry the installation once this conflict has been resolved.
70 EOF
71 exit 1
72 fi
73 fi
74
75 if [ -v KUBECFG ]; then
76 cat $KUBECFG | juju add-k8s $K8S_CLOUD_NAME $ADD_K8S_OPTS
77 [ -v BOOTSTRAP_NEEDED ] && juju bootstrap $K8S_CLOUD_NAME $CONTROLLER_NAME --config controller-service-type=loadbalancer
78 else
79 sg ${KUBEGRP} -c "echo ${DEFAULT_IP}-${DEFAULT_IP} | microk8s.enable metallb"
80 sg ${KUBEGRP} -c "microk8s.enable storage dns"
81 TIME_TO_WAIT=30
82 start_time="$(date -u +%s)"
83 while true
84 do
85 now="$(date -u +%s)"
86 if [[ $(( now - start_time )) -gt $TIME_TO_WAIT ]];then
87 echo "Microk8s storage failed to enable"
88 sg ${KUBEGRP} -c "microk8s.status"
89 exit 1
90 fi
91 storage_status=`sg ${KUBEGRP} -c "microk8s.status -a storage"`
92 if [[ $storage_status == "enabled" ]]; then
93 break
94 fi
95 sleep 1
96 done
97
98 [ ! -v BOOTSTRAP_NEEDED ] && sg ${KUBEGRP} -c "microk8s.config" | juju add-k8s $K8S_CLOUD_NAME $ADD_K8S_OPTS
99 [ -v BOOTSTRAP_NEEDED ] && sg ${KUBEGRP} -c "juju bootstrap microk8s $CONTROLLER_NAME --config controller-service-type=loadbalancer" && K8S_CLOUD_NAME=microk8s
100 fi
101
102 if [ -v LXD_CLOUD ]; then
103 if [ ! -v LXD_CREDENTIALS ]; then
104 echo "The installer needs the LXD server certificate if the LXD is external"
105 exit 1
106 fi
107 else
108 LXDENDPOINT=$DEFAULT_IP
109 LXD_CLOUD=~/.osm/lxd-cloud.yaml
110 LXD_CREDENTIALS=~/.osm/lxd-credentials.yaml
111 # Apply sysctl production values for optimal performance
112 sudo cp /usr/share/osm-devops/installers/60-lxd-production.conf /etc/sysctl.d/60-lxd-production.conf
113 sudo sysctl --system
114 # Install LXD snap
115 sudo apt-get remove --purge -y liblxc1 lxc-common lxcfs lxd lxd-client
116 sudo snap install lxd
117 # Configure LXD
118 sudo usermod -a -G lxd `whoami`
119 cat /usr/share/osm-devops/installers/lxd-preseed.conf | sed 's/^config: {}/config:\n core.https_address: '$LXDENDPOINT':8443/' | sg lxd -c "lxd init --preseed"
120 sg lxd -c "lxd waitready"
121 DEFAULT_MTU=$(ip addr show $DEFAULT_IF | perl -ne 'if (/mtu\s(\d+)/) {print $1;}')
122 sg lxd -c "lxc profile device set default eth0 mtu $DEFAULT_MTU"
123 sg lxd -c "lxc network set lxdbr0 bridge.mtu $DEFAULT_MTU"
124
125 cat << EOF > $LXD_CLOUD
126 clouds:
127 lxd-cloud:
128 type: lxd
129 auth-types: [certificate]
130 endpoint: "https://$LXDENDPOINT:8443"
131 config:
132 ssl-hostname-verification: false
133 EOF
134 openssl req -nodes -new -x509 -keyout ~/.osm/client.key -out ~/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
135 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
136 local client_cert=`cat ~/.osm/client.crt | sed 's/^/ /'`
137 local client_key=`cat ~/.osm/client.key | sed 's/^/ /'`
138
139 cat << EOF > $LXD_CREDENTIALS
140 credentials:
141 lxd-cloud:
142 lxd-cloud:
143 auth-type: certificate
144 server-cert: |
145 $server_cert
146 client-cert: |
147 $client_cert
148 client-key: |
149 $client_key
150 EOF
151 lxc config trust add local: ~/.osm/client.crt
152 fi
153
154 juju add-cloud -c $CONTROLLER_NAME lxd-cloud $LXD_CLOUD --force
155 juju add-credential -c $CONTROLLER_NAME lxd-cloud -f $LXD_CREDENTIALS
156 sg lxd -c "lxd waitready"
157 #juju add-model test lxd-cloud || true
158 juju controller-config features=[k8s-operators]
159 }
160
161 function wait_for_port(){
162 SERVICE=$1
163 INDEX=$2
164 TIME_TO_WAIT=30
165 start_time="$(date -u +%s)"
166 while true
167 do
168 now="$(date -u +%s)"
169 if [[ $(( now - start_time )) -gt $TIME_TO_WAIT ]];then
170 echo "Failed to expose external ${SERVICE} interface port"
171 exit 1
172 fi
173
174 if [ $(sg ${KUBEGRP} -c "${KUBECTL} get ingress -n osm -o json | jq -r '.items[$INDEX].metadata.name'") == ${SERVICE} ] ; then
175 break
176 fi
177 sleep 1
178 done
179 }
180
181 function deploy_charmed_osm(){
182 create_overlay
183 echo "Creating OSM model"
184 if [ -v KUBECFG ]; then
185 juju add-model osm $K8S_CLOUD_NAME
186 else
187 sg ${KUBEGRP} -c "juju add-model osm $K8S_CLOUD_NAME"
188 fi
189 echo "Deploying OSM with charms"
190 images_overlay=""
191 [ -v TAG ] && generate_images_overlay && images_overlay="--overlay $IMAGES_OVERLAY_FILE"
192 if [ -v BUNDLE ]; then
193 juju deploy $BUNDLE --overlay ~/.osm/vca-overlay.yaml $images_overlay
194 else
195 juju deploy cs:osm --overlay ~/.osm/vca-overlay.yaml $images_overlay
196 fi
197
198 echo "Waiting for deployment to finish..."
199 check_osm_deployed
200 echo "OSM with charms deployed"
201 if [ ! -v KUBECFG ]; then
202 sg ${KUBEGRP} -c "microk8s.enable ingress"
203 API_SERVER=${DEFAULT_IP}
204 else
205 API_SERVER=$(kubectl config view --minify | grep server | cut -f 2- -d ":" | tr -d " ")
206 proto="$(echo $API_SERVER | grep :// | sed -e's,^\(.*://\).*,\1,g')"
207 url="$(echo ${API_SERVER/$proto/})"
208 user="$(echo $url | grep @ | cut -d@ -f1)"
209 hostport="$(echo ${url/$user@/} | cut -d/ -f1)"
210 API_SERVER="$(echo $hostport | sed -e 's,:.*,,g')"
211 fi
212
213 # Expose OSM services
214 # Expose NBI
215 juju config nbi-k8s juju-external-hostname=nbi.${API_SERVER}.xip.io
216 juju expose nbi-k8s
217
218 # Expose NG UI
219 juju config ng-ui juju-external-hostname=ui.${API_SERVER}.xip.io
220 juju expose ng-ui
221
222 # Expose UI
223 juju config ui-k8s juju-external-hostname=osm.${API_SERVER}.xip.io
224 juju expose ui-k8s
225
226 # Wait for ingress resources to be applied
227 wait_for_port nbi-k8s 0
228 wait_for_port ng-ui 1
229 wait_for_port ui-k8s 2
230
231 # Apply annotations
232 sg ${KUBEGRP} -c "${KUBECTL} annotate ingress nginx.ingress.kubernetes.io/backend-protocol=HTTPS -n osm -l juju-app=nbi-k8s"
233 sg ${KUBEGRP} -c "${KUBECTL} annotate ingress nginx.ingress.kubernetes.io/proxy-body-size=0 -n osm -l juju-app=nbi-k8s"
234 sg ${KUBEGRP} -c "${KUBECTL} annotate ingress nginx.ingress.kubernetes.io/proxy-body-size=0 -n osm -l juju-app=ng-ui"
235 sg ${KUBEGRP} -c "${KUBECTL} annotate ingress nginx.ingress.kubernetes.io/proxy-body-size=0 -n osm -l juju-app=ui-k8s"
236
237
238 function check_osm_deployed() {
239 TIME_TO_WAIT=600
240 start_time="$(date -u +%s)"
241 total_service_count=14
242 while true
243 do
244 service_count=$(juju status | grep kubernetes | grep active | wc -l)
245 echo "$service_count / $total_service_count services active"
246 if [ $service_count -eq $total_service_count ]; then
247 break
248 fi
249 now="$(date -u +%s)"
250 if [[ $(( now - start_time )) -gt $TIME_TO_WAIT ]];then
251 echo "Timed out waiting for OSM services to become ready"
252 exit 1
253 fi
254 sleep 10
255 done
256 }
257
258 function create_overlay() {
259 sudo snap install jq
260 sudo apt install python3-pip -y
261 python3 -m pip install yq
262 PATH=$PATH:$HOME/.local/bin # make yq command available
263 local HOME=/home/$USER
264 local vca_user=$(cat $HOME/.local/share/juju/accounts.yaml | yq --arg CONTROLLER_NAME $CONTROLLER_NAME '.controllers[$CONTROLLER_NAME].user')
265 local vca_password=$(cat $HOME/.local/share/juju/accounts.yaml | yq --arg CONTROLLER_NAME $CONTROLLER_NAME '.controllers[$CONTROLLER_NAME].password')
266 local vca_host=$(cat $HOME/.local/share/juju/controllers.yaml | yq --arg CONTROLLER_NAME $CONTROLLER_NAME '.controllers[$CONTROLLER_NAME]["api-endpoints"][0]' --raw-output | cut -d ":" -f 1)
267 local vca_port=$(cat $HOME/.local/share/juju/controllers.yaml | yq --arg CONTROLLER_NAME $CONTROLLER_NAME '.controllers[$CONTROLLER_NAME]["api-endpoints"][0]' --raw-output | cut -d ":" -f 2)
268 local vca_pubkey=\"$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)\"
269 local vca_cloud="lxd-cloud"
270 # Get the VCA Certificate
271 local vca_cacert=$(cat $HOME/.local/share/juju/controllers.yaml | yq --arg CONTROLLER_NAME $CONTROLLER_NAME '.controllers[$CONTROLLER_NAME]["ca-cert"]' --raw-output | base64 | tr -d \\n)
272
273 # Calculate the default route of this machine
274 local DEFAULT_IF=`ip route list match 0.0.0.0 | awk '{print $5}'`
275
276 # Generate a new overlay.yaml, overriding any existing one
277 cat << EOF > /tmp/vca-overlay.yaml
278 applications:
279 lcm-k8s:
280 options:
281 vca_user: $vca_user
282 vca_password: $vca_password
283 vca_host: $vca_host
284 vca_port: $vca_port
285 vca_pubkey: $vca_pubkey
286 vca_cacert: $vca_cacert
287 vca_cloud: $vca_cloud
288 vca_k8s_cloud: $K8S_CLOUD_NAME
289 mon-k8s:
290 options:
291 vca_user: $vca_user
292 vca_password: $vca_password
293 vca_host: $vca_host
294 vca_cacert: $vca_cacert
295 EOF
296 mv /tmp/vca-overlay.yaml ~/.osm/
297 OSM_VCA_HOST=$vca_host
298 }
299
300 function generate_images_overlay(){
301 cat << EOF > /tmp/images-overlay.yaml
302 applications:
303 lcm-k8s:
304 options:
305 image: opensourcemano/lcm:$TAG
306 mon-k8s:
307 options:
308 image: opensourcemano/mon:$TAG
309 ro-k8s:
310 options:
311 image: opensourcemano/ro:$TAG
312 nbi-k8s:
313 options:
314 image: opensourcemano/nbi:$TAG
315 pol-k8s:
316 options:
317 image: opensourcemano/pol:$TAG
318 ui-k8s:
319 options:
320 image: opensourcemano/light-ui:$TAG
321 pla:
322 options:
323 image: opensourcemano/pla:$TAG
324 ng-ui:
325 options:
326 image: opensourcemano/ng-ui:$TAG
327 keystone:
328 options:
329 image: opensourcemano/keystone:$TAG
330
331 EOF
332 mv /tmp/images-overlay.yaml $IMAGES_OVERLAY_FILE
333 }
334
335 function install_osmclient() {
336 sudo snap install osmclient
337 sudo snap alias osmclient.osm osm
338 }
339
340
341 function install_microstack() {
342 sudo snap install microstack --classic --beta
343 sudo microstack.init --auto
344 wget https://cloud-images.ubuntu.com/releases/16.04/release/ubuntu-16.04-server-cloudimg-amd64-disk1.img -P ~/.osm/
345 microstack.openstack image create \
346 --public \
347 --disk-format qcow2 \
348 --container-format bare \
349 --file ~/.osm/ubuntu-16.04-server-cloudimg-amd64-disk1.img \
350 ubuntu1604
351 ssh-keygen -t rsa -N "" -f ~/.ssh/microstack
352 microstack.openstack keypair create --public-key ~/.ssh/microstack.pub microstack
353 export OSM_HOSTNAME=`juju status --format json | jq -rc '.applications."nbi-k8s".address'`
354 osm vim-create --name microstack-site \
355 --user admin \
356 --password keystone \
357 --auth_url http://10.20.20.1:5000/v3 \
358 --tenant admin \
359 --account_type openstack \
360 --config='{security_groups: default,
361 keypair: microstack,
362 project_name: admin,
363 user_domain_name: default,
364 region_name: microstack,
365 insecure: True,
366 availability_zone: nova,
367 version: 3}'
368 }
369
370 DEFAULT_IF=`ip route list match 0.0.0.0 | awk '{print $5}'`
371 DEFAULT_IP=`ip -o -4 a |grep ${DEFAULT_IF}|awk '{split($4,a,"/"); print a[1]}'`
372
373 check_arguments $@
374 mkdir -p ~/.osm
375 install_snaps
376 bootstrap_k8s_lxd
377 deploy_charmed_osm
378 install_osmclient
379 if [ -v MICROSTACK ]; then
380 install_microstack
381 fi
382
383 echo "Your installation is now complete, follow these steps for configuring the osmclient:"
384 echo
385 echo "1. Create the OSM_HOSTNAME environment variable with the NBI IP"
386 echo
387 echo "export OSM_HOSTNAME=nbi.$API_SERVER.xip.io:443"
388 echo
389 echo "2. Add the previous command to your .bashrc for other Shell sessions"
390 echo
391 echo "echo \"export OSM_HOSTNAME=nbi.$API_SERVER.xip.io:443\" >> ~/.bashrc"
392 echo
393 echo "DONE"